






//	This source and compression method apply to GNU General Public License. 
//			Copyright (C) 2008,2009,2010 Jasenko Dzinleski 



//		This program is free software; you can redistribute it
//	and/or modify it under the terms of the GNU General Public License as
//	published by the Free Software Foundation; either version 2 of the
//	License, or (at your option) any later version. 

//	This program is distributed in the hope that it will be useful, but
//	WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
//	General Public License for more details. 


//	You should have received a copy of the GNU General Public License along
//	with this program; if not, write to the Free Software Foundation, Inc.,
//	51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.



//
//			6-bit Binary Compression
//			written by Dzinleski Jasenko 2008,2009,2010
//
//			to Maria Dzinleska






#include 	<stdio.h>
#include 	<string.h>
#include 	<math.h>


#define		BuffC				128
#define		BuffLength			32*BuffC
#define		BtM					32*16*BuffC
#define		BtM4				4*32*16*BuffC
#define		TBEnd				32
#define		RBuffL				16397

char		c_l[256]="{[--]}{[hh][ee][cc][dd]}{[AZ][az][09][__][  ][..]}";

char 		infn[256]="book_sd.txt";
char		outfn[256]="t_.txt";

char		out1fn[256]="1_.mar";
char		out2fn[256]="2_.mar";
char		out3fn[256]="3_.mar";
char		out4fn[256]="4_.mar";
char		out5fn[256]="5_.mar";
char		out6fn[256]="6_.mar";
char		out7fn[256]="7_.mar";

FILE		*f1,*f2,*fo1,*fo2,*fo3,*fo4,*fo5,*fo6,*fo7;

bool		br[BtM];							int	bri=0;
bool		br_[BtM4];							int	bri_=0;
int			md[256][2];							int	mdi=0;
int			bpa[8][8];
int			ga[4][2];

bool		bt0[16];							int	bt0i=0;
bool		bt1[16];							int	bt1i=0;
bool		bt2[16];							int	bt2i=0;
bool		bt3[16];							int	bt3i=0;
bool		bt32_1[32];							int	bt32i_1=0;
bool		bt32_2[32];							int	bt32i_2=0;
bool		bt24[24];							int	bt24i=0;

bool		bt_d[4][16];		

int			cd[4][4];					

int			ba8[16][16];						int	ba8i=0;
int			ca6[256][256][256];					int	ca6i=0;
long		ca6_[64];							int	ca6i_=0;

int			ca_6[3*100000][3];					int	ca_6i=0;
			
long		ca[BuffLength];						int cai=0;
long		ca_[4*BuffLength];					int cai_=0;

int			pi,pj,pk,pl,fmdd_;
int			npr;
__int64		bitc=0;
__int64		bc=0,fb=0;

bool 		df=false;
bool		d_f=false;
bool		o_f=true;

int			bytc=0,bytc1=0;



int	c_p(char cl_a[256],int ci,bool tf,char r_a[256])
{

	int		a,b,c,d=0;
	
	for(a=0;a<256;++a){r_a[a]='\0';}

	if(tf)
	{
		for(a=0;a<strlen(c_l);++a){
			if(cl_a[a]=='{'){++d;for(b=a+1;b<strlen(cl_a);++b){if(cl_a[b]=='}'){if(d==ci){break;}}}}
			if(b!=strlen(cl_a)){break;}
		}
	}else{
		for(a=0;a<strlen(cl_a);++a){
			if(cl_a[a]=='['){++d;for(b=a+1;b<strlen(cl_a);++b){if(cl_a[b]==']'){if(d==ci){break;}}}}
			if(b!=strlen(cl_a)){break;}
		}
	}

	d=0;for(c=a+1;c<b;++c){r_a[d]=cl_a[c];++d;/*printf("%c",cl_a[c]);*/}

	return(0);

}

int	f_n(char n_infn[256],char n_outfn[256])
{

						int		i,j,k,l,m;
						char	fn[256];


						f1=fopen(n_infn,"rb");if(f1==NULL){return(0);}
						
						for(j=0;j<256;++j){fn[j]='\0';}
						strcpy(fn,n_infn);
						for(l=0;fn[l]!='.';++l){}for(m=0;out1fn[m]!='.';++m){}
						fn[l]='_';++l;
						for(k=l;k<l+m;++k){fn[k]=out1fn[k-l];}
						fn[k]='.';fn[++k]='m';fn[++k]='a';fn[++k]='r';
						//printf("%s\n",fn);
						for(k=0;k<strlen(fn);++k){out1fn[k]=fn[k];}
						
						for(j=0;j<256;++j){fn[j]='\0';}
						strcpy(fn,n_infn);
						for(l=0;fn[l]!='.';++l){}for(m=0;out2fn[m]!='.';++m){}
						fn[l]='_';++l;
						for(k=l;k<l+m;++k){fn[k]=out2fn[k-l];}
						fn[k]='.';fn[++k]='m';fn[++k]='a';fn[++k]='r';
						//printf("%s\n",fn);
						for(k=0;k<strlen(fn);++k){out2fn[k]=fn[k];}
						
						for(j=0;j<256;++j){fn[j]='\0';}
						strcpy(fn,n_infn);
						for(l=0;fn[l]!='.';++l){}for(m=0;out3fn[m]!='.';++m){}
						fn[l]='_';++l;
						for(k=l;k<l+m;++k){fn[k]=out3fn[k-l];}
						fn[k]='.';fn[++k]='m';fn[++k]='a';fn[++k]='r';
						//printf("%s\n",fn);
						for(k=0;k<strlen(fn);++k){out3fn[k]=fn[k];}

						for(j=0;j<256;++j){fn[j]='\0';}
						strcpy(fn,n_infn);
						for(l=0;fn[l]!='.';++l){}for(m=0;out4fn[m]!='.';++m){}
						fn[l]='_';++l;
						for(k=l;k<l+m;++k){fn[k]=out4fn[k-l];}
						fn[k]='.';fn[++k]='m';fn[++k]='a';fn[++k]='r';
						//printf("%s\n",fn);
						for(k=0;k<strlen(fn);++k){out4fn[k]=fn[k];}

						for(j=0;j<256;++j){fn[j]='\0';}
						strcpy(fn,n_infn);
						for(l=0;fn[l]!='.';++l){}for(m=0;out5fn[m]!='.';++m){}
						fn[l]='_';++l;
						for(k=l;k<l+m;++k){fn[k]=out5fn[k-l];}
						fn[k]='.';fn[++k]='m';fn[++k]='a';fn[++k]='r';
						//printf("%s\n",fn);
						for(k=0;k<strlen(fn);++k){out5fn[k]=fn[k];}

						for(j=0;j<256;++j){fn[j]='\0';}
						strcpy(fn,n_infn);
						for(l=0;fn[l]!='.';++l){}for(m=0;out6fn[m]!='.';++m){}
						fn[l]='_';++l;
						for(k=l;k<l+m;++k){fn[k]=out6fn[k-l];}
						fn[k]='.';fn[++k]='m';fn[++k]='a';fn[++k]='r';
						//printf("%s\n",fn);
						for(k=0;k<strlen(fn);++k){out6fn[k]=fn[k];}

						for(j=0;j<256;++j){fn[j]='\0';}
						strcpy(fn,n_infn);
						for(l=0;fn[l]!='.';++l){}for(m=0;out7fn[m]!='.';++m){}
						fn[l]='_';++l;
						for(k=l;k<l+m;++k){fn[k]=out7fn[k-l];}
						fn[k]='.';fn[++k]='m';fn[++k]='a';fn[++k]='r';
						//printf("%s\n",fn);
						for(k=0;k<strlen(fn);++k){out7fn[k]=fn[k];}

						if(n_outfn!=NULL){strcpy(outfn,n_outfn);o_f=true;}else{outfn[0]='\0';o_f=false;}

	return(0);
}

int	p_w(FILE *fw1,int d,bool brw[BtM],int brwi)
{
	int	i,ii=0,j,k,l;

	l=7;j=0;
	for(i=0;i<brwi;)
	{

		if(i+d<brwi-TBEnd){if(brw[i]  ){j|=1<<l;}--l;}else{break;}
		if(i+d<brwi-TBEnd){if(brw[++i]){j|=1<<l;}--l;}else{break;}
		if(i+d<brwi-TBEnd){if(brw[++i]){j|=1<<l;}--l;}else{break;}
		if(i+d<brwi-TBEnd){if(brw[++i]){j|=1<<l;}--l;}else{break;}
		if(i+d<brwi-TBEnd){if(brw[++i]){j|=1<<l;}--l;}else{break;}
		if(i+d<brwi-TBEnd){if(brw[++i]){j|=1<<l;}--l;}else{break;}
		if(i+d<brwi-TBEnd){if(brw[++i]){j|=1<<l;}--l;}else{break;}
		if(i+d<brwi-TBEnd){if(brw[++i]){j|=1<<l;}--l;}else{break;}

		if(l==-1){fprintf(fw1,"%c",(j&0x00ff));++bytc;++bytc1;l=7;j=0;++i;ii=i;}
					
	}if(i==brwi){brwi=0;}else{j=0;for(l=ii;l<brwi;++l){brw[j]=brw[l];++j;}brwi=j;}

	bitc+=i;

	return(0);

}

void pr32_(long d,bool b_[32],int b_i)
{

	b_i=0;
	if((((((d&0xff000000)>>24)<<24)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0xff000000)>>24)<<25)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0xff000000)>>24)<<26)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0xff000000)>>24)<<27)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0xff000000)>>24)<<28)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0xff000000)>>24)<<29)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0xff000000)>>24)<<30)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0xff000000)>>24)<<31)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}

	if((((((d&0x00ff0000)>>16)<<24)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0x00ff0000)>>16)<<25)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0x00ff0000)>>16)<<26)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0x00ff0000)>>16)<<27)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0x00ff0000)>>16)<<28)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0x00ff0000)>>16)<<29)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0x00ff0000)>>16)<<30)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0x00ff0000)>>16)<<31)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}

	if((((((d&0x0000ff00)>>8)<<24)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0x0000ff00)>>8)<<25)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0x0000ff00)>>8)<<26)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0x0000ff00)>>8)<<27)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0x0000ff00)>>8)<<28)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0x0000ff00)>>8)<<29)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0x0000ff00)>>8)<<30)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0x0000ff00)>>8)<<31)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}

	if(((((d&0x000000ff)<<24)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if(((((d&0x000000ff)<<25)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if(((((d&0x000000ff)<<26)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if(((((d&0x000000ff)<<27)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if(((((d&0x000000ff)<<28)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if(((((d&0x000000ff)<<29)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if(((((d&0x000000ff)<<30)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if(((((d&0x000000ff)<<31)>>31)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}

}

void pr16_(int d,bool b_[16],int b_i)
{

	b_i=0;

	if((((((d&0xff00)>>8)<< 8)>>15)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0xff00)>>8)<< 9)>>15)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0xff00)>>8)<<10)>>15)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0xff00)>>8)<<11)>>15)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0xff00)>>8)<<12)>>15)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0xff00)>>8)<<13)>>15)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0xff00)>>8)<<14)>>15)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if((((((d&0xff00)>>8)<<15)>>15)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}

	if(((((d&0x00ff)<< 8)>>15)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if(((((d&0x00ff)<< 9)>>15)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if(((((d&0x00ff)<<10)>>15)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if(((((d&0x00ff)<<11)>>15)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if(((((d&0x00ff)<<12)>>15)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if(((((d&0x00ff)<<13)>>15)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if(((((d&0x00ff)<<14)>>15)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}
	if(((((d&0x00ff)<<15)>>15)&0x1)==1){b_[b_i]=true;++b_i;}else{b_[b_i]=false;++b_i;}

}

void mc_()
{

	int		a,b,c;
	int		i,j,k,l,m,n;
	long	vgmi,vgm11,vgm12,vgm13;
	bool	df_c=false;
	int		bm[6];

	long	ls,ls1;

	//0001	 A
	//1110	!A

	//1100	 B
	//0011	!B

	//0111	 C
	//1000	!C

	//1111	 D
	//0000	!D

	//0101	 E
	//1010	!E

	//0110	 F
	//1001	!F

	//0100	 G
	//1011	!G

	//0010	 H
	//1101	!H

	//(3 + 1) * 6 = 24 bit

	a=10;
	for(i=0;i<6;++i)
	{
		if(!bt0[a]&&!bt1[a]&&!bt2[a]&& bt3[a])	
		{
			if(df_c){printf(" A");}
			bm[i]=0;++a;
			continue;
		}
		if( bt0[a]&& bt1[a]&& bt2[a]&&!bt3[a])	
		{
			if(df_c){printf("!A");}
			bm[i]=1;++a;
			continue;
		}

		if( bt0[a]&& bt1[a]&&!bt2[a]&&!bt3[a])	
		{
			if(df_c){printf(" B");}
			bm[i]=2;++a;
			continue;
		}
		if(!bt0[a]&&!bt1[a]&& bt2[a]&& bt3[a])	
		{
			if(df_c){printf("!B");}
			bm[i]=3;++a;
			continue;
		}

		if(!bt0[a]&& bt1[a]&& bt2[a]&& bt3[a])	
		{
			if(df_c){printf(" C");}
			bm[i]=4;++a;
			continue;
		}
		if( bt0[a]&&!bt1[a]&&!bt2[a]&&!bt3[a])	
		{
			if(df_c){printf("!C");}
			bm[i]=5;++a;
			continue;
		}

		if( bt0[a]&& bt1[a]&& bt2[a]&& bt3[a])	
		{
			if(df_c){printf(" D");}
			bm[i]=6;++a;
			continue;
		}
		if(!bt0[a]&&!bt1[a]&&!bt2[a]&&!bt3[a])	
		{
			if(df_c){printf("!D");}
			bm[i]=7;++a;
			continue;
		}

		if(!bt0[a]&& bt1[a]&&!bt2[a]&& bt3[a])	
		{
			if(df_c){printf(" E");}
			bm[i]=8;++a;
			continue;
		}
		if( bt0[a]&&!bt1[a]&& bt2[a]&&!bt3[a])	
		{
			if(df_c){printf("!E");}
			bm[i]=9;++a;
			continue;
		}

		if(!bt0[a]&& bt1[a]&& bt2[a]&&!bt3[a])	
		{
			if(df_c){printf(" F");}
			bm[i]=10;++a;
			continue;
		}
		if( bt0[a]&&!bt1[a]&&!bt2[a]&& bt3[a])	
		{
			if(df_c){printf("!F");}
			bm[i]=11;++a;
			continue;
		}

		if(!bt0[a]&& bt1[a]&&!bt2[a]&&!bt3[a])	
		{
			if(df_c){printf(" G");}
			bm[i]=12;++a;
			continue;
		}
		if( bt0[a]&&!bt1[a]&& bt2[a]&& bt3[a])	
		{
			if(df_c){printf("!G");}
			bm[i]=13;++a;
			continue;
		}

		if(!bt0[a]&&!bt1[a]&& bt2[a]&&!bt3[a])	
		{
			if(df_c){printf(" H");}
			bm[i]=14;++a;
			continue;
		}
		if( bt0[a]&& bt1[a]&&!bt2[a]&& bt3[a])	
		{
			if(df_c){printf("!H");}
			bm[i]=15;++a;
			continue;
		}
	}

	i=(bm[0]&0xf);j=(bm[1]&0xf);
	if(ba8[i][j]==-1)
	{
		ba8[i][j]=ba8i;vgm11=(ba8i&0xff);++ba8i;
	}else{vgm11=(ba8[i][j]&0xff);}
	i=(bm[2]&0xf);j=(bm[3]&0xf);
	if(ba8[i][j]==-1)
	{
		ba8[i][j]=ba8i;vgm12=(ba8i&0xff);++ba8i;
	}else{vgm12=(ba8[i][j]&0xff);}
	i=(bm[4]&0xf);j=(bm[5]&0xf);
	if(ba8[i][j]==-1)
	{
		ba8[i][j]=ba8i;vgm13=(ba8i&0xff);++ba8i;
	}else{vgm13=(ba8[i][j]&0xff);}

	//ls=(vgm11<<16)|(vgm12<<8)|(vgm13<<0);

	if(ca6[vgm11][vgm12][vgm13]==-1)
	{
		ca6[vgm11][vgm12][vgm13]=ca6i;vgmi=ca6i;++ca6i;
		fprintf(fo3,"%c",(vgm11&0xff));
		fprintf(fo3,"%c",(vgm12&0xff));
		fprintf(fo3,"%c",(vgm13&0xff));
		bitc+=3*8;
	}else{
		vgmi=ca6[vgm11][vgm12][vgm13];
	}
	ca[cai]=vgmi;++cai;
}

int mdd_(int sbri_)
{

	int		i,j,k,l,m,n,r,p,q;
	int		a,b,c,d,e,f;
	long	g;

	int		r11,r12,r13,r14;
	int		r21,r22,r23,r24;
	int		r31,r32,r33,r34;

	int		bm[6];
	int		ii1,ii2,ii3,ii4;

	int		brii=-1;
	int		l1,l2;
	long	ls,ls1,ls2;

	if(sbri_==0)
	{
		f=0;
		if(br_[++brii]){f|=1<<4;}
		if(br_[++brii]){f|=1<<3;}
		if(br_[++brii]){f|=1<<2;}
		if(br_[++brii]){f|=1<<1;}
		if(br_[++brii]){f|=1<<0;}
		fmdd_=f;

		if(d_f){printf(".%d.\n",f);}
		sbri_=brii;

	}else{f=fmdd_;}

	ls=0;
	for(c=sbri_;c+1<bri_;)
	{
		if(f==6) 
		{
			g=0;
			if(br_[++c]){g|=1<<5; }
			if(br_[++c]){g|=1<<4; }
			if(br_[++c]){g|=1<<3; }
			if(br_[++c]){g|=1<<2; }
			if(br_[++c]){g|=1<<1; }
			if(br_[++c]){g|=1<<0; }

		}
		if(f==5) 
		{
			g=0;
			if(br_[++c]){g|=1<<4; }
			if(br_[++c]){g|=1<<3; }
			if(br_[++c]){g|=1<<2; }
			if(br_[++c]){g|=1<<1; }
			if(br_[++c]){g|=1<<0; }

		}

		if(d_f){printf("r===%d %d %d===\n",g,i,j);}

		++ls;
		if(ls==1){pi=ca6_[g];}
		if(ls==2){pj=ca6_[g];}
		if(ls==3){pk=ca6_[g];}
		if(ls==4){pl=ca6_[g];break;}

	}
	return(c);
}

void md_()
{

	int		i,j,k,l,m,n,r,p,q,si=0,sc=0;
	int		a,b,c,d,e,f;
	long	g;

	int		r11,r12,r13,r14;
	int		r21,r22,r23,r24;
	int		r31,r32,r33,r34;

	int		bm[6];
	int		ii1,ii2,ii3,ii4;

	int		brii=-1;
	int		l1,l2;
	long	ls,ls1,ls2;

	f=0;
	if(br[++brii]){f|=1<<4;}
	if(br[++brii]){f|=1<<3;}
	if(br[++brii]){f|=1<<2;}
	if(br[++brii]){f|=1<<1;}
	if(br[++brii]){f|=1<<0;}

	if(d_f){printf(".%d.\n",f);}//printf(".%d.\n",f);

	q=0;
	for(c=brii;c+1<bri;)
	{
		if(f==28)
		{

			g=0;
			if(br[++c]){g|=1<<27; }
			if(br[++c]){g|=1<<26; }
			if(br[++c]){g|=1<<25; }
			if(br[++c]){g|=1<<24; }
			if(br[++c]){g|=1<<23; }
			if(br[++c]){g|=1<<22; }
			if(br[++c]){g|=1<<21; }
			if(br[++c]){g|=1<<20; }
			if(br[++c]){g|=1<<19; }
			if(br[++c]){g|=1<<18; }
			if(br[++c]){g|=1<<17; }
			if(br[++c]){g|=1<<16; }
			if(br[++c]){g|=1<<15; }
			if(br[++c]){g|=1<<14; }
			if(br[++c]){g|=1<<13;}
			if(br[++c]){g|=1<<12;}
			if(br[++c]){g|=1<<11;}
			if(br[++c]){g|=1<<10;}
			if(br[++c]){g|=1<<9; }
			if(br[++c]){g|=1<<8; }
			if(br[++c]){g|=1<<7; }
			if(br[++c]){g|=1<<6; }
			if(br[++c]){g|=1<<5; }
			if(br[++c]){g|=1<<4; }
			if(br[++c]){g|=1<<3; }
			if(br[++c]){g|=1<<2; }
			if(br[++c]){g|=1<<1; }
			if(br[++c]){g|=1<<0; }

		}
		if(f==27)
		{

			g=0;
			if(br[++c]){g|=1<<26; }
			if(br[++c]){g|=1<<25; }
			if(br[++c]){g|=1<<24; }
			if(br[++c]){g|=1<<23; }
			if(br[++c]){g|=1<<22; }
			if(br[++c]){g|=1<<21; }
			if(br[++c]){g|=1<<20; }
			if(br[++c]){g|=1<<19; }
			if(br[++c]){g|=1<<18; }
			if(br[++c]){g|=1<<17; }
			if(br[++c]){g|=1<<16; }
			if(br[++c]){g|=1<<15; }
			if(br[++c]){g|=1<<14; }
			if(br[++c]){g|=1<<13;}
			if(br[++c]){g|=1<<12;}
			if(br[++c]){g|=1<<11;}
			if(br[++c]){g|=1<<10;}
			if(br[++c]){g|=1<<9; }
			if(br[++c]){g|=1<<8; }
			if(br[++c]){g|=1<<7; }
			if(br[++c]){g|=1<<6; }
			if(br[++c]){g|=1<<5; }
			if(br[++c]){g|=1<<4; }
			if(br[++c]){g|=1<<3; }
			if(br[++c]){g|=1<<2; }
			if(br[++c]){g|=1<<1; }
			if(br[++c]){g|=1<<0; }

		}
		if(f==26)
		{

			g=0;
			if(br[++c]){g|=1<<25; }
			if(br[++c]){g|=1<<24; }
			if(br[++c]){g|=1<<23; }
			if(br[++c]){g|=1<<22; }
			if(br[++c]){g|=1<<21; }
			if(br[++c]){g|=1<<20; }
			if(br[++c]){g|=1<<19; }
			if(br[++c]){g|=1<<18; }
			if(br[++c]){g|=1<<17; }
			if(br[++c]){g|=1<<16; }
			if(br[++c]){g|=1<<15; }
			if(br[++c]){g|=1<<14; }
			if(br[++c]){g|=1<<13;}
			if(br[++c]){g|=1<<12;}
			if(br[++c]){g|=1<<11;}
			if(br[++c]){g|=1<<10;}
			if(br[++c]){g|=1<<9; }
			if(br[++c]){g|=1<<8; }
			if(br[++c]){g|=1<<7; }
			if(br[++c]){g|=1<<6; }
			if(br[++c]){g|=1<<5; }
			if(br[++c]){g|=1<<4; }
			if(br[++c]){g|=1<<3; }
			if(br[++c]){g|=1<<2; }
			if(br[++c]){g|=1<<1; }
			if(br[++c]){g|=1<<0; }

		}
		if(f==25)
		{

			g=0;
			if(br[++c]){g|=1<<24; }
			if(br[++c]){g|=1<<23; }
			if(br[++c]){g|=1<<22; }
			if(br[++c]){g|=1<<21; }
			if(br[++c]){g|=1<<20; }
			if(br[++c]){g|=1<<19; }
			if(br[++c]){g|=1<<18; }
			if(br[++c]){g|=1<<17; }
			if(br[++c]){g|=1<<16; }
			if(br[++c]){g|=1<<15; }
			if(br[++c]){g|=1<<14; }
			if(br[++c]){g|=1<<13;}
			if(br[++c]){g|=1<<12;}
			if(br[++c]){g|=1<<11;}
			if(br[++c]){g|=1<<10;}
			if(br[++c]){g|=1<<9; }
			if(br[++c]){g|=1<<8; }
			if(br[++c]){g|=1<<7; }
			if(br[++c]){g|=1<<6; }
			if(br[++c]){g|=1<<5; }
			if(br[++c]){g|=1<<4; }
			if(br[++c]){g|=1<<3; }
			if(br[++c]){g|=1<<2; }
			if(br[++c]){g|=1<<1; }
			if(br[++c]){g|=1<<0; }

		}
		if(f==24)
		{

			g=0;
			if(br[++c]){g|=1<<23; }
			if(br[++c]){g|=1<<22; }
			if(br[++c]){g|=1<<21; }
			if(br[++c]){g|=1<<20; }
			if(br[++c]){g|=1<<19; }
			if(br[++c]){g|=1<<18; }
			if(br[++c]){g|=1<<17; }
			if(br[++c]){g|=1<<16; }
			if(br[++c]){g|=1<<15; }
			if(br[++c]){g|=1<<14; }
			if(br[++c]){g|=1<<13;}
			if(br[++c]){g|=1<<12;}
			if(br[++c]){g|=1<<11;}
			if(br[++c]){g|=1<<10;}
			if(br[++c]){g|=1<<9; }
			if(br[++c]){g|=1<<8; }
			if(br[++c]){g|=1<<7; }
			if(br[++c]){g|=1<<6; }
			if(br[++c]){g|=1<<5; }
			if(br[++c]){g|=1<<4; }
			if(br[++c]){g|=1<<3; }
			if(br[++c]){g|=1<<2; }
			if(br[++c]){g|=1<<1; }
			if(br[++c]){g|=1<<0; }

		}
		if(f==23)
		{

			g=0;
			if(br[++c]){g|=1<<22; }
			if(br[++c]){g|=1<<21; }
			if(br[++c]){g|=1<<20; }
			if(br[++c]){g|=1<<19; }
			if(br[++c]){g|=1<<18; }
			if(br[++c]){g|=1<<17; }
			if(br[++c]){g|=1<<16; }
			if(br[++c]){g|=1<<15; }
			if(br[++c]){g|=1<<14; }
			if(br[++c]){g|=1<<13;}
			if(br[++c]){g|=1<<12;}
			if(br[++c]){g|=1<<11;}
			if(br[++c]){g|=1<<10;}
			if(br[++c]){g|=1<<9; }
			if(br[++c]){g|=1<<8; }
			if(br[++c]){g|=1<<7; }
			if(br[++c]){g|=1<<6; }
			if(br[++c]){g|=1<<5; }
			if(br[++c]){g|=1<<4; }
			if(br[++c]){g|=1<<3; }
			if(br[++c]){g|=1<<2; }
			if(br[++c]){g|=1<<1; }
			if(br[++c]){g|=1<<0; }

		}
		if(f==22)
		{

			g=0;
			if(br[++c]){g|=1<<21; }
			if(br[++c]){g|=1<<20; }
			if(br[++c]){g|=1<<19; }
			if(br[++c]){g|=1<<18; }
			if(br[++c]){g|=1<<17; }
			if(br[++c]){g|=1<<16; }
			if(br[++c]){g|=1<<15; }
			if(br[++c]){g|=1<<14; }
			if(br[++c]){g|=1<<13;}
			if(br[++c]){g|=1<<12;}
			if(br[++c]){g|=1<<11;}
			if(br[++c]){g|=1<<10;}
			if(br[++c]){g|=1<<9; }
			if(br[++c]){g|=1<<8; }
			if(br[++c]){g|=1<<7; }
			if(br[++c]){g|=1<<6; }
			if(br[++c]){g|=1<<5; }
			if(br[++c]){g|=1<<4; }
			if(br[++c]){g|=1<<3; }
			if(br[++c]){g|=1<<2; }
			if(br[++c]){g|=1<<1; }
			if(br[++c]){g|=1<<0; }

		}
		if(f==21)
		{

			g=0;
			if(br[++c]){g|=1<<20; }
			if(br[++c]){g|=1<<19; }
			if(br[++c]){g|=1<<18; }
			if(br[++c]){g|=1<<17; }
			if(br[++c]){g|=1<<16; }
			if(br[++c]){g|=1<<15; }
			if(br[++c]){g|=1<<14; }
			if(br[++c]){g|=1<<13;}
			if(br[++c]){g|=1<<12;}
			if(br[++c]){g|=1<<11;}
			if(br[++c]){g|=1<<10;}
			if(br[++c]){g|=1<<9; }
			if(br[++c]){g|=1<<8; }
			if(br[++c]){g|=1<<7; }
			if(br[++c]){g|=1<<6; }
			if(br[++c]){g|=1<<5; }
			if(br[++c]){g|=1<<4; }
			if(br[++c]){g|=1<<3; }
			if(br[++c]){g|=1<<2; }
			if(br[++c]){g|=1<<1; }
			if(br[++c]){g|=1<<0; }	

		}
		if(f==20)
		{

			g=0;
			if(br[++c]){g|=1<<19; }
			if(br[++c]){g|=1<<18; }
			if(br[++c]){g|=1<<17; }
			if(br[++c]){g|=1<<16; }
			if(br[++c]){g|=1<<15; }
			if(br[++c]){g|=1<<14; }
			if(br[++c]){g|=1<<13;}
			if(br[++c]){g|=1<<12;}
			if(br[++c]){g|=1<<11;}
			if(br[++c]){g|=1<<10;}
			if(br[++c]){g|=1<<9; }
			if(br[++c]){g|=1<<8; }
			if(br[++c]){g|=1<<7; }
			if(br[++c]){g|=1<<6; }
			if(br[++c]){g|=1<<5; }
			if(br[++c]){g|=1<<4; }
			if(br[++c]){g|=1<<3; }
			if(br[++c]){g|=1<<2; }
			if(br[++c]){g|=1<<1; }
			if(br[++c]){g|=1<<0; }

		}
		if(f==19)
		{

			g=0;
			if(br[++c]){g|=1<<18; }
			if(br[++c]){g|=1<<17; }
			if(br[++c]){g|=1<<16; }
			if(br[++c]){g|=1<<15; }
			if(br[++c]){g|=1<<14; }
			if(br[++c]){g|=1<<13;}
			if(br[++c]){g|=1<<12;}
			if(br[++c]){g|=1<<11;}
			if(br[++c]){g|=1<<10;}
			if(br[++c]){g|=1<<9; }
			if(br[++c]){g|=1<<8; }
			if(br[++c]){g|=1<<7; }
			if(br[++c]){g|=1<<6; }
			if(br[++c]){g|=1<<5; }
			if(br[++c]){g|=1<<4; }
			if(br[++c]){g|=1<<3; }
			if(br[++c]){g|=1<<2; }
			if(br[++c]){g|=1<<1; }
			if(br[++c]){g|=1<<0; }

		}
		if(f==18)
		{

			g=0;
			if(br[++c]){g|=1<<17; }
			if(br[++c]){g|=1<<16; }
			if(br[++c]){g|=1<<15; }
			if(br[++c]){g|=1<<14; }
			if(br[++c]){g|=1<<13;}
			if(br[++c]){g|=1<<12;}
			if(br[++c]){g|=1<<11;}
			if(br[++c]){g|=1<<10;}
			if(br[++c]){g|=1<<9; }
			if(br[++c]){g|=1<<8; }
			if(br[++c]){g|=1<<7; }
			if(br[++c]){g|=1<<6; }
			if(br[++c]){g|=1<<5; }
			if(br[++c]){g|=1<<4; }
			if(br[++c]){g|=1<<3; }
			if(br[++c]){g|=1<<2; }
			if(br[++c]){g|=1<<1; }
			if(br[++c]){g|=1<<0; }

		}
		if(f==17)
		{

			g=0;
			if(br[++c]){g|=1<<16; }
			if(br[++c]){g|=1<<15; }
			if(br[++c]){g|=1<<14; }
			if(br[++c]){g|=1<<13;}
			if(br[++c]){g|=1<<12;}
			if(br[++c]){g|=1<<11;}
			if(br[++c]){g|=1<<10;}
			if(br[++c]){g|=1<<9; }
			if(br[++c]){g|=1<<8; }
			if(br[++c]){g|=1<<7; }
			if(br[++c]){g|=1<<6; }
			if(br[++c]){g|=1<<5; }
			if(br[++c]){g|=1<<4; }
			if(br[++c]){g|=1<<3; }
			if(br[++c]){g|=1<<2; }
			if(br[++c]){g|=1<<1; }
			if(br[++c]){g|=1<<0; }

		}
		if(f==16)
		{

			g=0;
			if(br[++c]){g|=1<<15; }
			if(br[++c]){g|=1<<14; }
			if(br[++c]){g|=1<<13;}
			if(br[++c]){g|=1<<12;}
			if(br[++c]){g|=1<<11;}
			if(br[++c]){g|=1<<10;}
			if(br[++c]){g|=1<<9; }
			if(br[++c]){g|=1<<8; }
			if(br[++c]){g|=1<<7; }
			if(br[++c]){g|=1<<6; }
			if(br[++c]){g|=1<<5; }
			if(br[++c]){g|=1<<4; }
			if(br[++c]){g|=1<<3; }
			if(br[++c]){g|=1<<2; }
			if(br[++c]){g|=1<<1; }
			if(br[++c]){g|=1<<0; }

		}
		if(f==15)
		{

			g=0;
			if(br[++c]){g|=1<<14; }
			if(br[++c]){g|=1<<13;}
			if(br[++c]){g|=1<<12;}
			if(br[++c]){g|=1<<11;}
			if(br[++c]){g|=1<<10;}
			if(br[++c]){g|=1<<9; }
			if(br[++c]){g|=1<<8; }
			if(br[++c]){g|=1<<7; }
			if(br[++c]){g|=1<<6; }
			if(br[++c]){g|=1<<5; }
			if(br[++c]){g|=1<<4; }
			if(br[++c]){g|=1<<3; }
			if(br[++c]){g|=1<<2; }
			if(br[++c]){g|=1<<1; }
			if(br[++c]){g|=1<<0; }

		}
		if(f==14)
		{
			g=0;
			if(br[++c]){g|=1<<13;}
			if(br[++c]){g|=1<<12;}
			if(br[++c]){g|=1<<11;}
			if(br[++c]){g|=1<<10;}
			if(br[++c]){g|=1<<9; }
			if(br[++c]){g|=1<<8; }
			if(br[++c]){g|=1<<7; }
			if(br[++c]){g|=1<<6; }
			if(br[++c]){g|=1<<5; }
			if(br[++c]){g|=1<<4; }
			if(br[++c]){g|=1<<3; }
			if(br[++c]){g|=1<<2; }
			if(br[++c]){g|=1<<1; }
			if(br[++c]){g|=1<<0; }

		}
		if(f==13)
		{
			g=0;
			if(br[++c]){g|=1<<12;}
			if(br[++c]){g|=1<<11;}
			if(br[++c]){g|=1<<10;}
			if(br[++c]){g|=1<<9; }
			if(br[++c]){g|=1<<8; }
			if(br[++c]){g|=1<<7; }
			if(br[++c]){g|=1<<6; }
			if(br[++c]){g|=1<<5; }
			if(br[++c]){g|=1<<4; }
			if(br[++c]){g|=1<<3; }
			if(br[++c]){g|=1<<2; }
			if(br[++c]){g|=1<<1; }
			if(br[++c]){g|=1<<0; }

		}
		if(f==12) 
		{
			g=0;
			if(br[++c]){g|=1<<11;}
			if(br[++c]){g|=1<<10;}
			if(br[++c]){g|=1<<9; }
			if(br[++c]){g|=1<<8; }
			if(br[++c]){g|=1<<7; }
			if(br[++c]){g|=1<<6; }
			if(br[++c]){g|=1<<5; }
			if(br[++c]){g|=1<<4; }
			if(br[++c]){g|=1<<3; }
			if(br[++c]){g|=1<<2; }
			if(br[++c]){g|=1<<1; }
			if(br[++c]){g|=1<<0; }

		}
		if(f==11) 
		{
			g=0;
			if(br[++c]){g|=1<<10;}
			if(br[++c]){g|=1<<9; }
			if(br[++c]){g|=1<<8; }
			if(br[++c]){g|=1<<7; }
			if(br[++c]){g|=1<<6; }
			if(br[++c]){g|=1<<5; }
			if(br[++c]){g|=1<<4; }
			if(br[++c]){g|=1<<3; }
			if(br[++c]){g|=1<<2; }
			if(br[++c]){g|=1<<1; }
			if(br[++c]){g|=1<<0; }

		}
		if(f==10) 
		{
			g=0;
			if(br[++c]){g|=1<<9; }
			if(br[++c]){g|=1<<8; }
			if(br[++c]){g|=1<<7; }
			if(br[++c]){g|=1<<6; }
			if(br[++c]){g|=1<<5; }
			if(br[++c]){g|=1<<4; }
			if(br[++c]){g|=1<<3; }
			if(br[++c]){g|=1<<2; }
			if(br[++c]){g|=1<<1; }
			if(br[++c]){g|=1<<0; }

		}
		if(f==9) 
		{
			g=0;
			if(br[++c]){g|=1<<8; }
			if(br[++c]){g|=1<<7; }
			if(br[++c]){g|=1<<6; }
			if(br[++c]){g|=1<<5; }
			if(br[++c]){g|=1<<4; }
			if(br[++c]){g|=1<<3; }
			if(br[++c]){g|=1<<2; }
			if(br[++c]){g|=1<<1; }
			if(br[++c]){g|=1<<0; }

		}
		if(f==8) 
		{
			g=0;
			if(br[++c]){g|=1<<7; }
			if(br[++c]){g|=1<<6; }
			if(br[++c]){g|=1<<5; }
			if(br[++c]){g|=1<<4; }
			if(br[++c]){g|=1<<3; }
			if(br[++c]){g|=1<<2; }
			if(br[++c]){g|=1<<1; }
			if(br[++c]){g|=1<<0; }

		}
		if(f==7) 
		{
			g=0;
			if(br[++c]){g|=1<<6; }
			if(br[++c]){g|=1<<5; }
			if(br[++c]){g|=1<<4; }
			if(br[++c]){g|=1<<3; }
			if(br[++c]){g|=1<<2; }
			if(br[++c]){g|=1<<1; }
			if(br[++c]){g|=1<<0; }

		}
		if(f==6) 
		{
			g=0;
			if(br[++c]){g|=1<<5; }
			if(br[++c]){g|=1<<4; }
			if(br[++c]){g|=1<<3; }
			if(br[++c]){g|=1<<2; }
			if(br[++c]){g|=1<<1; }
			if(br[++c]){g|=1<<0; }

		}

		if(d_f){printf("r===%d %d %d===\n",g,i,j);}

		//for(a=0;a<256;++a){for(b=0;b<256;++b){for(d=0;d<256;++d){
		//	if(ca6[a][b][d]==g){break;}
		//}if(d!=256){break;}}if(b!=256){break;}}

		for(i=0;i<16;++i){for(j=0;j<16;++j){
			if(ba8[i][j]==ca_6[g][0]){break;}
		}if(j!=16){break;}}

		bm[0]=i;
		bm[1]=j;

		for(i=0;i<16;++i){for(j=0;j<16;++j){
			if(ba8[i][j]==ca_6[g][1]){break;}
		}if(j!=16){break;}}

		bm[2]=i;
		bm[3]=j;

		for(i=0;i<16;++i){for(j=0;j<16;++j){
			if(ba8[i][j]==ca_6[g][2]){break;}
		}if(j!=16){break;}}

		bm[4]=i;
		bm[5]=j;

		//printf("r.%d %d %d.\n",i,j,k);

		b=0;
		for(a=0;a<6;++a)
		{
					if(bm[a]==0)
					{
						bt_d[0][10+b]=false;
						bt_d[1][10+b]=false;
						bt_d[2][10+b]=false;
						bt_d[3][10+b]=true;
						++b;
						continue;
					}
					if(bm[a]==1)
					{
						bt_d[0][10+b]=true;
						bt_d[1][10+b]=true;
						bt_d[2][10+b]=true;
						bt_d[3][10+b]=false;
						++b;
						continue;
					}
					if(bm[a]==2)
					{
						bt_d[0][10+b]=true;
						bt_d[1][10+b]=true;
						bt_d[2][10+b]=false;
						bt_d[3][10+b]=false;
						++b;
						continue;
					}
					if(bm[a]==3)
					{
						bt_d[0][10+b]=false;
						bt_d[1][10+b]=false;
						bt_d[2][10+b]=true;
						bt_d[3][10+b]=true;
						++b;
						continue;
					}
					if(bm[a]==4)
					{
						bt_d[0][10+b]=false;
						bt_d[1][10+b]=true;
						bt_d[2][10+b]=true;
						bt_d[3][10+b]=true;
						++b;
						continue;
					}
					if(bm[a]==5)
					{
						bt_d[0][10+b]=true;
						bt_d[1][10+b]=false;
						bt_d[2][10+b]=false;
						bt_d[3][10+b]=false;
						++b;
						continue;
					}
					if(bm[a]==6)
					{
						bt_d[0][10+b]=true;
						bt_d[1][10+b]=true;
						bt_d[2][10+b]=true;
						bt_d[3][10+b]=true;
						++b;
						continue;
					}
					if(bm[a]==7)
					{
						bt_d[0][10+b]=false;
						bt_d[1][10+b]=false;
						bt_d[2][10+b]=false;
						bt_d[3][10+b]=false;
						++b;
						continue;
					}
					if(bm[a]==8)
					{
						bt_d[0][10+b]=false;
						bt_d[1][10+b]=true;
						bt_d[2][10+b]=false;
						bt_d[3][10+b]=true;
						++b;
						continue;
					}
					if(bm[a]==9)
					{
						bt_d[0][10+b]=true;
						bt_d[1][10+b]=false;
						bt_d[2][10+b]=true;
						bt_d[3][10+b]=false;
						++b;
						continue;
					}
					if(bm[a]==10)
					{
						bt_d[0][10+b]=false;
						bt_d[1][10+b]=true;
						bt_d[2][10+b]=true;
						bt_d[3][10+b]=false;
						++b;
						continue;
					}
					if(bm[a]==11)
					{
						bt_d[0][10+b]=true;
						bt_d[1][10+b]=false;
						bt_d[2][10+b]=false;
						bt_d[3][10+b]=true;
						++b;
						continue;
					}
					if(bm[a]==12)
					{
						bt_d[0][10+b]=false;
						bt_d[1][10+b]=true;
						bt_d[2][10+b]=false;
						bt_d[3][10+b]=false;
						++b;
						continue;
					}
					if(bm[a]==13)
					{
						bt_d[0][10+b]=true;
						bt_d[1][10+b]=false;
						bt_d[2][10+b]=true;
						bt_d[3][10+b]=true;
						++b;
						continue;
					}
					if(bm[a]==14)
					{
						bt_d[0][10+b]=false;
						bt_d[1][10+b]=false;
						bt_d[2][10+b]=true;
						bt_d[3][10+b]=false;
						++b;
						continue;
					}
					if(bm[a]==15)
					{
						bt_d[0][10+b]=true;
						bt_d[1][10+b]=true;
						bt_d[2][10+b]=false;
						bt_d[3][10+b]=true;
						++b;
						continue;
					}
		}

		ii1=0;
		if(bt_d[0][10]){ii1|=1<<5;}
		if(bt_d[0][11]){ii1|=1<<4;}
		if(bt_d[0][12]){ii1|=1<<3;}
		if(bt_d[0][13]){ii1|=1<<2;}
		if(bt_d[0][14]){ii1|=1<<1;}
		if(bt_d[0][15]){ii1|=1<<0;}

		ii2=0;
		if(bt_d[1][10]){ii2|=1<<5;}
		if(bt_d[1][11]){ii2|=1<<4;}
		if(bt_d[1][12]){ii2|=1<<3;}
		if(bt_d[1][13]){ii2|=1<<2;}
		if(bt_d[1][14]){ii2|=1<<1;}
		if(bt_d[1][15]){ii2|=1<<0;}

		ii3=0;
		if(bt_d[2][10]){ii3|=1<<5;}
		if(bt_d[2][11]){ii3|=1<<4;}
		if(bt_d[2][12]){ii3|=1<<3;}
		if(bt_d[2][13]){ii3|=1<<2;}
		if(bt_d[2][14]){ii3|=1<<1;}
		if(bt_d[2][15]){ii3|=1<<0;}

		ii4=0;
		if(bt_d[3][10]){ii4|=1<<5;}
		if(bt_d[3][11]){ii4|=1<<4;}
		if(bt_d[3][12]){ii4|=1<<3;}
		if(bt_d[3][13]){ii4|=1<<2;}
		if(bt_d[3][14]){ii4|=1<<1;}
		if(bt_d[3][15]){ii4|=1<<0;}

		cd[q][0]=ii1;
		cd[q][1]=ii2;
		cd[q][2]=ii3;
		cd[q][3]=ii4;

		++q;
		if(q==3)
		{
				q=0;

				si=mdd_(si);
				//printf("!!!.%d %d %d %d.\n",ii1,ii2,ii3,ii4);
				//printf("!!!.%d %d %d %d.\n",pi,pj,pk,pl);
				
				for(a=0;a<256;++a){if(md[a][0]!=-1){if(md[a][1]==cd[0][0]){r11=a;break;}}}
				for(a=0;a<256;++a){if(md[a][0]!=-1){if(md[a][1]==cd[0][1]){r12=a;break;}}}
				for(a=0;a<256;++a){if(md[a][0]!=-1){if(md[a][1]==cd[0][2]){r13=a;break;}}}
				for(a=0;a<256;++a){if(md[a][0]!=-1){if(md[a][1]==cd[0][3]){r14=a;break;}}}

				l=0;for(a=0;a<8;++a){for(b=0;b<8;++b){if(r11==l){r11=bpa[a][b]+((pi&0x30)>>4);break;}++l;}if(b!=8){break;}}
				l=0;for(a=0;a<8;++a){for(b=0;b<8;++b){if(r12==l){r12=bpa[a][b]+((pi&0xc )>>2);break;}++l;}if(b!=8){break;}}
				l=0;for(a=0;a<8;++a){for(b=0;b<8;++b){if(r13==l){r13=bpa[a][b]+((pi&0x3 )>>0);break;}++l;}if(b!=8){break;}}
				l=0;for(a=0;a<8;++a){for(b=0;b<8;++b){if(r14==l){r14=bpa[a][b]+((pj&0x30)>>4);break;}++l;}if(b!=8){break;}}

				for(a=0;a<256;++a){if(md[a][0]!=-1){if(md[a][1]==cd[1][0]){r21=a;break;}}}
				for(a=0;a<256;++a){if(md[a][0]!=-1){if(md[a][1]==cd[1][1]){r22=a;break;}}}
				for(a=0;a<256;++a){if(md[a][0]!=-1){if(md[a][1]==cd[1][2]){r23=a;break;}}}
				for(a=0;a<256;++a){if(md[a][0]!=-1){if(md[a][1]==cd[1][3]){r24=a;break;}}}

				l=0;for(a=0;a<8;++a){for(b=0;b<8;++b){if(r21==l){r21=bpa[a][b]+((pj&0xc )>>2);break;}++l;}if(b!=8){break;}}
				l=0;for(a=0;a<8;++a){for(b=0;b<8;++b){if(r22==l){r22=bpa[a][b]+((pj&0x3 )>>0);break;}++l;}if(b!=8){break;}}
				l=0;for(a=0;a<8;++a){for(b=0;b<8;++b){if(r23==l){r23=bpa[a][b]+((pk&0x30)>>4);break;}++l;}if(b!=8){break;}}
				l=0;for(a=0;a<8;++a){for(b=0;b<8;++b){if(r24==l){r24=bpa[a][b]+((pk&0xc )>>2);break;}++l;}if(b!=8){break;}}

				for(a=0;a<256;++a){if(md[a][0]!=-1){if(md[a][1]==cd[2][0]){r31=a;break;}}}
				for(a=0;a<256;++a){if(md[a][0]!=-1){if(md[a][1]==cd[2][1]){r32=a;break;}}}
				for(a=0;a<256;++a){if(md[a][0]!=-1){if(md[a][1]==cd[2][2]){r33=a;break;}}}
				for(a=0;a<256;++a){if(md[a][0]!=-1){if(md[a][1]==cd[2][3]){r34=a;break;}}}

				l=0;for(a=0;a<8;++a){for(b=0;b<8;++b){if(r31==l){r31=bpa[a][b]+((pk&0x3 )>>0);break;}++l;}if(b!=8){break;}}
				l=0;for(a=0;a<8;++a){for(b=0;b<8;++b){if(r32==l){r32=bpa[a][b]+((pl&0x30)>>4);break;}++l;}if(b!=8){break;}}
				l=0;for(a=0;a<8;++a){for(b=0;b<8;++b){if(r33==l){r33=bpa[a][b]+((pl&0xc )>>2);break;}++l;}if(b!=8){break;}}
				l=0;for(a=0;a<8;++a){for(b=0;b<8;++b){if(r34==l){r34=bpa[a][b]+((pl&0x3 )>>0);break;}++l;}if(b!=8){break;}}

				if(o_f)
				{
					fprintf(f2,"%c%c%c%c",r11,r12,r13,r14);
					fprintf(f2,"%c%c%c%c",r21,r22,r23,r24);
					fprintf(f2,"%c%c%c%c",r31,r32,r33,r34);
				}else{
					printf("%c%c%c%c",r11,r12,r13,r14);
					printf("%c%c%c%c",r21,r22,r23,r24);
					printf("%c%c%c%c",r31,r32,r33,r34);
				}
		}
	}
}

int mw4_()
{

	int	i,j,k,l,m,n,p,a,b,c,d;

	fo1=fopen(out1fn,"ab");
	m=-1;for(i=0;i<cai;++i)
	{

		pr32_(ca[i] ,bt32_1,bt32i_1);
		p=32;for(a=0;a<32;++a){if(bt32_1[a]){p=a;break;}}
		if(m==-1){m=a;}else{if(m>a){m=a;}}

	}n=m;m=32-m;//printf(".%d.",m);printf(".%d.",ca6i);
	if(d_f){printf(".%d.",m);}

	bri=0;
	pr32_(m ,bt32_1, bt32i_1);
	
	br[bri]=bt32_1[27];++bri;
	br[bri]=bt32_1[28];++bri;
	br[bri]=bt32_1[29];++bri;
	br[bri]=bt32_1[30];++bri;
	br[bri]=bt32_1[31];++bri;

	for(c=0;c<cai;++c)
	{

		if(d_f){printf("w===%d ===\n",ca[c]);}

		pr32_(ca[c] ,bt32_1,bt32i_1);
		p=32;for(a=0;a<32;++a){if(bt32_1[a]){p=a;break;}}//printf(".%d.",p-n);
		if(p>n){for(b=n;b<p;++b){br[bri]=false;++bri;}for(b=p;b<32;++b){br[bri]=bt32_1[b];++bri;}}else{
			if(p==n){for(b=n;b<32;++b){br[bri]=bt32_1[b];++bri;}}else{printf("BL Error...%d %d\n",p,n);}
		}

		if(!(bri_<BtM-TBEnd)){p_w(fo1,m,br,bri);}
	}

	if(bri!=0)
	{
		j=0;l=7;
		for(i=0;i<bri;)
		{

			if(i  <bri){if(br[i]  ){j|=1<<l;}--l;}else{break;}//{fprintf(f2,"%c",(j&0x00ff));break;}
			if(i+1<bri){if(br[++i]){j|=1<<l;}--l;}else{break;}//{fprintf(f2,"%c",(j&0x00ff));break;}
			if(i+1<bri){if(br[++i]){j|=1<<l;}--l;}else{break;}//{fprintf(f2,"%c",(j&0x00ff));break;}
			if(i+1<bri){if(br[++i]){j|=1<<l;}--l;}else{break;}//{fprintf(f2,"%c",(j&0x00ff));break;}
			if(i+1<bri){if(br[++i]){j|=1<<l;}--l;}else{break;}//{fprintf(f2,"%c",(j&0x00ff));break;}
			if(i+1<bri){if(br[++i]){j|=1<<l;}--l;}else{break;}//{fprintf(f2,"%c",(j&0x00ff));break;}
			if(i+1<bri){if(br[++i]){j|=1<<l;}--l;}else{break;}//{fprintf(f2,"%c",(j&0x00ff));break;}
			if(i+1<bri){if(br[++i]){j|=1<<l;}--l;}else{break;}//{fprintf(f2,"%c",(j&0x00ff));break;}

			if(l==-1){fprintf(fo1,"%c",(j&0x00ff));++bytc;l=7;j=0;++i;}

		}

		bitc+=i;

		if(7-l==1)
		{
			j=0;
			if(br[-1+bri]){j|=1<<7;}
			fprintf(fo1,"%c",(j&0x00ff));++bytc;
		}

		if(7-l==2)
		{
			j=0;
			if(br[-2+bri]){j|=1<<7;}
			if(br[-1+bri]){j|=1<<6;}
			fprintf(fo1,"%c",(j&0x00ff));++bytc;
		}

		if(7-l==3)
		{
			j=0;
			if(br[-3+bri]){j|=1<<7;}
			if(br[-2+bri]){j|=1<<6;}
			if(br[-1+bri]){j|=1<<5;}
			fprintf(fo1,"%c",(j&0x00ff));++bytc;
		}

		if(7-l==4)
		{
			j=0;
			if(br[-4+bri]){j|=1<<7;}
			if(br[-3+bri]){j|=1<<6;}
			if(br[-2+bri]){j|=1<<5;}
			if(br[-1+bri]){j|=1<<4;}
			fprintf(fo1,"%c",(j&0x00ff));++bytc;
		}

		if(7-l==5)
		{
			j=0;
			if(br[-5+bri]){j|=1<<7;}
			if(br[-4+bri]){j|=1<<6;}
			if(br[-3+bri]){j|=1<<5;}
			if(br[-2+bri]){j|=1<<4;}
			if(br[-1+bri]){j|=1<<3;}
			fprintf(fo1,"%c",(j&0x00ff));++bytc;
		}

		if(7-l==6)
		{
			j=0;
			if(br[-6+bri]){j|=1<<7;}
			if(br[-5+bri]){j|=1<<6;}
			if(br[-4+bri]){j|=1<<5;}
			if(br[-3+bri]){j|=1<<4;}
			if(br[-2+bri]){j|=1<<3;}
			if(br[-1+bri]){j|=1<<2;}
			fprintf(fo1,"%c",(j&0x00ff));++bytc;
		}

		if(7-l==7)
		{
			j=0;
			if(br[-7+bri]){j|=1<<7;}
			if(br[-6+bri]){j|=1<<6;}
			if(br[-5+bri]){j|=1<<5;}
			if(br[-4+bri]){j|=1<<4;}
			if(br[-3+bri]){j|=1<<3;}
			if(br[-2+bri]){j|=1<<2;}
			if(br[-1+bri]){j|=1<<1;}
			fprintf(fo1,"%c",(j&0x00ff));++bytc;
		}

	}
	fclose(fo1);
}

int mw16_()
{

	int	i,j,k,l,m,n,p,a,b,c,d;

	fo2=fopen(out2fn,"ab");
	m=-1;for(i=0;i<cai_;++i)
	{

		pr16_(ca_[i] ,bt0,bt0i);
		p=16;for(a=0;a<16;++a){if(bt0[a]){p=a;break;}}
		if(m==-1){m=a;}else{if(m>a){m=a;}}

	}n=m;m=16-m;//printf(".%d.",m);printf(".%d.",ca6i_);
	if(d_f){printf(".%d.",m);}

	bri_=0;
	pr16_(m ,bt0, bt0i);
	
	br_[bri_]=bt0[11];++bri_;
	br_[bri_]=bt0[12];++bri_;
	br_[bri_]=bt0[13];++bri_;
	br_[bri_]=bt0[14];++bri_;
	br_[bri_]=bt0[15];++bri_;

	for(c=0;c<cai_;++c)
	{

		if(d_f){printf("w===%d ===\n",ca_[i]);}

		pr16_(ca_[c] ,bt0,bt0i);
		p=16;for(a=0;a<16;++a){if(bt0[a]){p=a;break;}}//printf(".%d.",p-n);
		if(p>n){for(b=n;b<p;++b){br_[bri_]=false;++bri_;}for(b=p;b<16;++b){br_[bri_]=bt0[b];++bri_;}}else{
			if(p==n){for(b=n;b<16;++b){br_[bri_]=bt0[b];++bri_;}}else{printf("BL Error...%d %d\n",p,n);}
		}

		if(!(bri_<BtM-TBEnd)){p_w(fo2,m,br_,bri_);}
	}

	if(bri_!=0)
	{
		j=0;l=7;
		for(i=0;i<bri_;)
		{

			if(i  <bri_){if(br_[i]  ){j|=1<<l;}--l;}else{break;}//{fprintf(f2,"%c",(j&0x00ff));break;}
			if(i+1<bri_){if(br_[++i]){j|=1<<l;}--l;}else{break;}//{fprintf(f2,"%c",(j&0x00ff));break;}
			if(i+1<bri_){if(br_[++i]){j|=1<<l;}--l;}else{break;}//{fprintf(f2,"%c",(j&0x00ff));break;}
			if(i+1<bri_){if(br_[++i]){j|=1<<l;}--l;}else{break;}//{fprintf(f2,"%c",(j&0x00ff));break;}
			if(i+1<bri_){if(br_[++i]){j|=1<<l;}--l;}else{break;}//{fprintf(f2,"%c",(j&0x00ff));break;}
			if(i+1<bri_){if(br_[++i]){j|=1<<l;}--l;}else{break;}//{fprintf(f2,"%c",(j&0x00ff));break;}
			if(i+1<bri_){if(br_[++i]){j|=1<<l;}--l;}else{break;}//{fprintf(f2,"%c",(j&0x00ff));break;}
			if(i+1<bri_){if(br_[++i]){j|=1<<l;}--l;}else{break;}//{fprintf(f2,"%c",(j&0x00ff));break;}

			if(l==-1){fprintf(fo2,"%c",(j&0x00ff));l=7;++bytc1;j=0;++i;}

		}

		bitc+=i;

		if(7-l==1)
		{
			j=0;
			if(br_[-1+bri_]){j|=1<<7;}
			fprintf(fo2,"%c",(j&0x00ff));++bytc1;
		}

		if(7-l==2)
		{
			j=0;
			if(br_[-2+bri_]){j|=1<<7;}
			if(br_[-1+bri_]){j|=1<<6;}
			fprintf(fo2,"%c",(j&0x00ff));++bytc1;
		}

		if(7-l==3)
		{
			j=0;
			if(br_[-3+bri_]){j|=1<<7;}
			if(br_[-2+bri_]){j|=1<<6;}
			if(br_[-1+bri_]){j|=1<<5;}
			fprintf(fo2,"%c",(j&0x00ff));++bytc1;
		}

		if(7-l==4)
		{
			j=0;
			if(br_[-4+bri_]){j|=1<<7;}
			if(br_[-3+bri_]){j|=1<<6;}
			if(br_[-2+bri_]){j|=1<<5;}
			if(br_[-1+bri_]){j|=1<<4;}
			fprintf(fo2,"%c",(j&0x00ff));++bytc1;
		}

		if(7-l==5)
		{
			j=0;
			if(br_[-5+bri_]){j|=1<<7;}
			if(br_[-4+bri_]){j|=1<<6;}
			if(br_[-3+bri_]){j|=1<<5;}
			if(br_[-2+bri_]){j|=1<<4;}
			if(br_[-1+bri_]){j|=1<<3;}
			fprintf(fo2,"%c",(j&0x00ff));++bytc1;
		}

		if(7-l==6)
		{
			j=0;
			if(br_[-6+bri_]){j|=1<<7;}
			if(br_[-5+bri_]){j|=1<<6;}
			if(br_[-4+bri_]){j|=1<<5;}
			if(br_[-3+bri_]){j|=1<<4;}
			if(br_[-2+bri_]){j|=1<<3;}
			if(br_[-1+bri_]){j|=1<<2;}
			fprintf(fo2,"%c",(j&0x00ff));++bytc1;
		}

		if(7-l==0)
		{
			j=0;
			if(br_[-7+bri_]){j|=1<<7;}
			if(br_[-6+bri_]){j|=1<<6;}
			if(br_[-5+bri_]){j|=1<<5;}
			if(br_[-4+bri_]){j|=1<<4;}
			if(br_[-3+bri_]){j|=1<<3;}
			if(br_[-2+bri_]){j|=1<<2;}
			if(br_[-1+bri_]){j|=1<<1;}
			fprintf(fo2,"%c",(j&0x00ff));++bytc1;
		}

	}
	fclose(fo2);

}

void m_d()
{
	int		fbyte1,fbyte2,fbyte3,fbyte4,fbyte5,fbyte6,fbyte7;
	int		i,j,k,l,m,n,r,p;
	int		c,d,cl,dl;

	long	ls;

//-----------------------------------------------

	ca6i=0;
	fo3=fopen(out3fn,"rb");
	c=0;fbyte3=getc(fo3);
	while(!feof(fo3))
	{

		pr16_(fbyte3 ,bt0,bt0i);
		i=0;
		if(bt0[8]) {i|=1<<7;};
		if(bt0[9]) {i|=1<<6;};
		if(bt0[10]){i|=1<<5;};
		if(bt0[11]){i|=1<<4;};
		if(bt0[12]){i|=1<<3;};
		if(bt0[13]){i|=1<<2;};
		if(bt0[14]){i|=1<<1;};
		if(bt0[15]){i|=1<<0;};

		fbyte3=getc(fo3);
		pr16_(fbyte3 ,bt0,bt0i);
		j=0;
		if(bt0[8]) {j|=1<<7;};
		if(bt0[9]) {j|=1<<6;};
		if(bt0[10]){j|=1<<5;};
		if(bt0[11]){j|=1<<4;};
		if(bt0[12]){j|=1<<3;};
		if(bt0[13]){j|=1<<2;};
		if(bt0[14]){j|=1<<1;};
		if(bt0[15]){j|=1<<0;};

		fbyte3=getc(fo3);
		pr16_(fbyte3 ,bt0,bt0i);
		k=0;
		if(bt0[8]) {k|=1<<7;};
		if(bt0[9]) {k|=1<<6;};
		if(bt0[10]){k|=1<<5;};
		if(bt0[11]){k|=1<<4;};
		if(bt0[12]){k|=1<<3;};
		if(bt0[13]){k|=1<<2;};
		if(bt0[14]){k|=1<<1;};
		if(bt0[15]){k|=1<<0;};

		//if(((i<<16)|(j<<8)|(k<<0))==ca6[c]){}else{printf("!");}
		//++c;
		ca_6[ca_6i][0]=i;
		ca_6[ca_6i][1]=j;
		ca_6[ca_6i][2]=k;		
		++ca_6i;
		
		fbyte3=getc(fo3);
	}
	fclose(fo3);

	ca6i_=0;

	fo4=fopen(out4fn,"rb");
	c=0;fbyte4=getc(fo4);
	while(!feof(fo4))
	{
		pr16_(fbyte4 ,bt0,bt0i);
		k=0;
		if(bt0[8]) {k|=1<<7;};
		if(bt0[9]) {k|=1<<6;};
		if(bt0[10]){k|=1<<5;};
		if(bt0[11]){k|=1<<4;};
		if(bt0[12]){k|=1<<3;};
		if(bt0[13]){k|=1<<2;};
		if(bt0[14]){k|=1<<1;};
		if(bt0[15]){k|=1<<0;};

		//if(k==ca6_[c]){}else{printf("!");}
		//++c;
		ca6_[ca6i_]=k;++ca6i_;

		fbyte4=getc(fo4);
	}
	fclose(fo4);

	ba8i=0;

	fo6=fopen(out6fn,"rb");
	c=0;fbyte6=getc(fo6);
	while(!feof(fo6))
	{
		pr16_(fbyte6 ,bt0,bt0i);
		k=0;
		if(bt0[8]) {k|=1<<7;};
		if(bt0[9]) {k|=1<<6;};
		if(bt0[10]){k|=1<<5;};
		if(bt0[11]){k|=1<<4;};
		if(bt0[12]){k|=1<<3;};
		if(bt0[13]){k|=1<<2;};
		if(bt0[14]){k|=1<<1;};
		if(bt0[15]){k|=1<<0;};

		//for(i=0;i<16;++i){for(j=0;j<16;++j){
		//	if(ba8[i][j]==c){break;}
		//}if(j!=16){break;}}
		//if(i==((k&0xf0)>>4)){if(j==((k&0x0f)>>0)){}else{printf("!");}}
		//++c;

		ba8[((k&0xf0)>>4)][(k&0x0f)]=ba8i;++ba8i;

		fbyte6=getc(fo6);
	}
	fclose(fo6);

	fo7=fopen(out7fn,"rb");
	c=0;fbyte7=getc(fo7);
	while(!feof(fo7))
	{
		pr16_(fbyte7 ,bt0,bt0i);
		i=0;
		if(bt0[8]) {i|=1<<7;};
		if(bt0[9]) {i|=1<<6;};
		if(bt0[10]){i|=1<<5;};
		if(bt0[11]){i|=1<<4;};
		if(bt0[12]){i|=1<<3;};
		if(bt0[13]){i|=1<<2;};
		if(bt0[14]){i|=1<<1;};
		if(bt0[15]){i|=1<<0;};

		fbyte7=getc(fo7);
		pr16_(fbyte7 ,bt0,bt0i);
		j=0;
		if(bt0[8]) {j|=1<<7;};
		if(bt0[9]) {j|=1<<6;};
		if(bt0[10]){j|=1<<5;};
		if(bt0[11]){j|=1<<4;};
		if(bt0[12]){j|=1<<3;};
		if(bt0[13]){j|=1<<2;};
		if(bt0[14]){j|=1<<1;};
		if(bt0[15]){j|=1<<0;};

		//if(md[i][1]==j){}else{printf("!");}
		//++c;
		
		md[i][0]=1;
		md[i][1]=j;

		fbyte7=getc(fo7);
	}
	fclose(fo7);

//-----------------------------------------------

	if(o_f){f2=fopen(outfn,"wb");}

	fo1=fopen(out1fn,"rb");
	fo2=fopen(out2fn,"rb");
	fo5=fopen(out5fn,"rb");
	fbyte5=getc(fo5);cl=fbyte5<<8;fbyte5=getc(fo5);cl|=fbyte5;
	fbyte5=getc(fo5);dl=fbyte5<<8;fbyte5=getc(fo5);dl|=fbyte5;
	//printf("===%d===\n",cl);
	fbyte1=getc(fo1);fbyte2=getc(fo2);
		
	while(!feof(fo1)&&!feof(fo2))
	{
		c=1;bri=0;
		while(c<cl&&!feof(fo1))
		{
			pr16_(fbyte1 ,bt0,bt0i);

			br[bri]=bt0[8]; ++bri;if(!(bri<cl*8)){break;}
			br[bri]=bt0[9]; ++bri;if(!(bri<cl*8)){break;}
			br[bri]=bt0[10];++bri;if(!(bri<cl*8)){break;}
			br[bri]=bt0[11];++bri;if(!(bri<cl*8)){break;}
			br[bri]=bt0[12];++bri;if(!(bri<cl*8)){break;}
			br[bri]=bt0[13];++bri;if(!(bri<cl*8)){break;}
			br[bri]=bt0[14];++bri;if(!(bri<cl*8)){break;}
			br[bri]=bt0[15];++bri;if(!(bri<cl*8)){break;}

			fbyte1=getc(fo1);++c;
		}fbyte1=getc(fo1);++c;

		d=1;bri_=0;
		while(d<dl&&!feof(fo2))
		{
			pr16_(fbyte2 ,bt0,bt0i);

			br_[bri_]=bt0[8]; ++bri_;if(!(bri_<dl*8)){break;}
			br_[bri_]=bt0[9]; ++bri_;if(!(bri_<dl*8)){break;}
			br_[bri_]=bt0[10];++bri_;if(!(bri_<dl*8)){break;}
			br_[bri_]=bt0[11];++bri_;if(!(bri_<dl*8)){break;}
			br_[bri_]=bt0[12];++bri_;if(!(bri_<dl*8)){break;}
			br_[bri_]=bt0[13];++bri_;if(!(bri_<dl*8)){break;}
			br_[bri_]=bt0[14];++bri_;if(!(bri_<dl*8)){break;}
			br_[bri_]=bt0[15];++bri_;if(!(bri_<dl*8)){break;}

			fbyte2=getc(fo2);++d;
		}fbyte2=getc(fo2);++d;
		
		md_();

		fbyte5=getc(fo5);cl=fbyte5<<8;fbyte5=getc(fo5);cl|=fbyte5;if(cl==-1){break;}
		fbyte5=getc(fo5);dl=fbyte5<<8;fbyte5=getc(fo5);dl|=fbyte5;if(dl==-1){break;}
		//printf("===%d===\n",cl);
	}

	fclose(fo1);	
	fclose(fo2);
	fclose(fo5);

	if(o_f){fclose(f2);}

}


int m_m(char mfn[256])
{


	int		fbyte,fbyte1,fbyte2,fbyte3,fbyte4,fbyte5,fbyte6,fbyte7;

	int		i,j,k,l,m,n,r,p;
	int		a,b,c,d,e;
	int		bb;
	int		ii[6];	

	int		a11,a12,a13,a14;
	int		a21,a22,a23,a24;

	int		vgmi;
	long	ls;	

	
	
//	printf("\n6-bit Binary Compression\n");
//	printf("written by Dzinleski Jasenko 2008,2009,2010\n");
//	printf("\nOS Win32 VRM 3.3.0\n\n");



//	256

//	000 : 000 - 000,003,012,015,048,051,060,063,192,195,204,207,240,243,252,255,
//	001 : 001 - 001,002,013,014,049,050,061,062,193,194,205,206,241,242,253,254,
//	004 : 004 - 004,007,008,011,052,055,056,059,196,199,200,203,244,247,248,251,
//	005 : 005 - 005,006,009,010,053,054,057,058,197,198,201,202,245,246,249,250,
//	016 : 016 - 016,019,028,031,032,035,044,047,208,211,220,223,224,227,236,239,
//	017 : 017 - 017,018,029,030,033,034,045,046,209,210,221,222,225,226,237,238,
//	020 : 020 - 020,023,024,027,036,039,040,043,212,215,216,219,228,231,232,235,
//	021 : 021 - 021,022,025,026,037,038,041,042,213,214,217,218,229,230,233,234,
//	064 : 064 - 064,067,076,079,112,115,124,127,128,131,140,143,176,179,188,191,
//	065 : 065 - 065,066,077,078,113,114,125,126,129,130,141,142,177,178,189,190,
//	068 : 068 - 068,071,072,075,116,119,120,123,132,135,136,139,180,183,184,187,
//	069 : 069 - 069,070,073,074,117,118,121,122,133,134,137,138,181,182,185,186,
//	080 : 080 - 080,083,092,095,096,099,108,111,144,147,156,159,160,163,172,175,
//	081 : 081 - 081,082,093,094,097,098,109,110,145,146,157,158,161,162,173,174,
//	084 : 084 - 084,087,088,091,100,103,104,107,148,151,152,155,164,167,168,171,
//	085 : 085 - 085,086,089,090,101,102,105,106,149,150,153,154,165,166,169,170,

//	bpa[0][0]=0  ;bpa[0][1]=4  ;bpa[0][2]=16 ;bpa[0][3]=20 ;bpa[0][4]=64 ;bpa[0][5]=68 ;bpa[0][6]=80 ;bpa[0][7]=84 ;
//	bpa[1][0]=12 ;bpa[1][1]=8  ;bpa[1][2]=28 ;bpa[1][3]=24 ;bpa[1][4]=76 ;bpa[1][5]=72 ;bpa[1][6]=92 ;bpa[1][7]=88 ;
//	bpa[2][0]=48 ;bpa[2][1]=52 ;bpa[2][2]=32 ;bpa[2][3]=36 ;bpa[2][4]=112;bpa[2][5]=116;bpa[2][6]=96 ;bpa[2][7]=100;
//	bpa[3][0]=60 ;bpa[3][1]=56 ;bpa[3][2]=44 ;bpa[3][3]=40 ;bpa[3][4]=124;bpa[3][5]=120;bpa[3][6]=108;bpa[3][7]=104;
//	bpa[4][0]=192;bpa[4][1]=196;bpa[4][2]=208;bpa[4][3]=212;bpa[4][4]=128;bpa[4][5]=132;bpa[4][6]=144;bpa[4][7]=148;
//	bpa[5][0]=204;bpa[5][1]=200;bpa[5][2]=220;bpa[5][3]=216;bpa[5][4]=140;bpa[5][5]=136;bpa[5][6]=156;bpa[5][7]=152;
//	bpa[6][0]=240;bpa[6][1]=244;bpa[6][2]=224;bpa[6][3]=228;bpa[6][4]=176;bpa[6][5]=180;bpa[6][6]=160;bpa[6][7]=164;
//	bpa[7][0]=252;bpa[7][1]=248;bpa[7][2]=236;bpa[7][3]=232;bpa[7][4]=188;bpa[7][5]=184;bpa[7][6]=172;bpa[7][7]=168;

	//for(i=0;i<16;++i){for(j=0;j<16;++j){
	//	ba8[i][j]=-1;
	//}}ba8i=0;

	//for(i=0;i<256;++i){md[i][0]=-1;}mdi=0;
	


	if(strlen(mfn)>0){strcpy(infn,mfn);}else{return(0);}
	f1=fopen(infn,"rb");if(f1==NULL){printf("No file...\n");return(1);}

	fo1=fopen(out1fn,"w");
	fclose(fo1);

	fo2=fopen(out2fn,"w");
	fclose(fo2);

	fo3=fopen(out3fn,"w");
	fclose(fo3);

	fo4=fopen(out4fn,"w");
	fclose(fo4);

	fo5=fopen(out5fn,"wb");

	fo6=fopen(out6fn,"w");
	fclose(fo6);

	fo7=fopen(out7fn,"w");
	fclose(fo7);
	
	fo3=fopen(out3fn,"ab");
	
	l=0;e=0;r=0;
	while(1>0)
	{

		n=getc(f1);fb+=8;//printf(".%c.",n);
		if(feof(f1)){n=0;}

		c=0;d=0;
		for(a=0;a<8;++a)
		{
			for(b=0;b<8;++b)
			{
				if(c+bpa[a][b]==n){break;}
			}
			if(b==8)
			{
				if(c<3+1){++c;--a;if(c==3+1){c=0;++a;}}
			}else{break;}				
		}

		bb=a*8+b;
		d=c;
		if(md[bb][0]==-1)
		{

			md[bb][0]=1;
			md[bb][1]=mdi;
			ga[e][0]=mdi;
			ga[e][1]=d;
			++mdi;

			if(mdi>=256){printf("Index Overflow...\n");return(-1);}

		}else{++md[bb][0];ga[e][0]=md[bb][1];ga[e][1]=d;}

		++e;
		if(e==4)
		{

			e=0;			
			pr16_(ga[0][0] ,bt0,bt0i);
			pr16_(ga[1][0] ,bt1,bt1i);
			pr16_(ga[2][0] ,bt2,bt2i);
			pr16_(ga[3][0] ,bt3,bt3i);
			mc_();

			++r;
			if(r==1)
			{

				for(i=0;i<16;++i){bt0[i]=false;}bt0i=16-8;
				if(((((ga[0][1]&0x3)<<14)>>15)&0x1)==1){bt0[bt0i]=true;++bt0i;}else{bt0[bt0i]=false;++bt0i;}
				if(((((ga[0][1]&0x3)<<15)>>15)&0x1)==1){bt0[bt0i]=true;++bt0i;}else{bt0[bt0i]=false;++bt0i;}

				if(((((ga[1][1]&0x3)<<14)>>15)&0x1)==1){bt0[bt0i]=true;++bt0i;}else{bt0[bt0i]=false;++bt0i;}
				if(((((ga[1][1]&0x3)<<15)>>15)&0x1)==1){bt0[bt0i]=true;++bt0i;}else{bt0[bt0i]=false;++bt0i;}

				if(((((ga[2][1]&0x3)<<14)>>15)&0x1)==1){bt0[bt0i]=true;++bt0i;}else{bt0[bt0i]=false;++bt0i;}
				if(((((ga[2][1]&0x3)<<15)>>15)&0x1)==1){bt0[bt0i]=true;++bt0i;}else{bt0[bt0i]=false;++bt0i;}

				if(((((ga[3][1]&0x3)<<14)>>15)&0x1)==1){bt0[bt0i]=true;++bt0i;}else{bt0[bt0i]=false;++bt0i;}
				if(((((ga[3][1]&0x3)<<15)>>15)&0x1)==1){bt0[bt0i]=true;++bt0i;}else{bt0[bt0i]=false;++bt0i;}

				a21=0;
				j=8-1;
				if(bt0[++j]){a21|=1<<5;}
				if(bt0[++j]){a21|=1<<4;}
				if(bt0[++j]){a21|=1<<3;}
				if(bt0[++j]){a21|=1<<2;}
				if(bt0[++j]){a21|=1<<1;}
				if(bt0[++j]){a21|=1<<0;}
				a22=0;
				if(bt0[++j]){a22|=1<<5;}
				if(bt0[++j]){a22|=1<<4;}

			}
			if(r==2)
			{

				for(i=0;i<16;++i){bt0[i]=false;}bt0i=16-8;
				if(((((ga[0][1]&0x3)<<14)>>15)&0x1)==1){bt0[bt0i]=true;++bt0i;}else{bt0[bt0i]=false;++bt0i;}
				if(((((ga[0][1]&0x3)<<15)>>15)&0x1)==1){bt0[bt0i]=true;++bt0i;}else{bt0[bt0i]=false;++bt0i;}

				if(((((ga[1][1]&0x3)<<14)>>15)&0x1)==1){bt0[bt0i]=true;++bt0i;}else{bt0[bt0i]=false;++bt0i;}
				if(((((ga[1][1]&0x3)<<15)>>15)&0x1)==1){bt0[bt0i]=true;++bt0i;}else{bt0[bt0i]=false;++bt0i;}

				if(((((ga[2][1]&0x3)<<14)>>15)&0x1)==1){bt0[bt0i]=true;++bt0i;}else{bt0[bt0i]=false;++bt0i;}
				if(((((ga[2][1]&0x3)<<15)>>15)&0x1)==1){bt0[bt0i]=true;++bt0i;}else{bt0[bt0i]=false;++bt0i;}

				if(((((ga[3][1]&0x3)<<14)>>15)&0x1)==1){bt0[bt0i]=true;++bt0i;}else{bt0[bt0i]=false;++bt0i;}
				if(((((ga[3][1]&0x3)<<15)>>15)&0x1)==1){bt0[bt0i]=true;++bt0i;}else{bt0[bt0i]=false;++bt0i;}

				j=8-1;
				if(bt0[++j]){a22|=1<<3;}
				if(bt0[++j]){a22|=1<<2;}
				if(bt0[++j]){a22|=1<<1;}
				if(bt0[++j]){a22|=1<<0;}

				a23=0;
				if(bt0[++j]){a23|=1<<5;}
				if(bt0[++j]){a23|=1<<4;}
				if(bt0[++j]){a23|=1<<3;}
				if(bt0[++j]){a23|=1<<2;}

			}
			if(r==3)
			{

				r=0;

				for(i=0;i<16;++i){bt0[i]=false;}bt0i=16-8;
				if(((((ga[0][1]&0x3)<<14)>>15)&0x1)==1){bt0[bt0i]=true;++bt0i;}else{bt0[bt0i]=false;++bt0i;}
				if(((((ga[0][1]&0x3)<<15)>>15)&0x1)==1){bt0[bt0i]=true;++bt0i;}else{bt0[bt0i]=false;++bt0i;}

				if(((((ga[1][1]&0x3)<<14)>>15)&0x1)==1){bt0[bt0i]=true;++bt0i;}else{bt0[bt0i]=false;++bt0i;}
				if(((((ga[1][1]&0x3)<<15)>>15)&0x1)==1){bt0[bt0i]=true;++bt0i;}else{bt0[bt0i]=false;++bt0i;}

				if(((((ga[2][1]&0x3)<<14)>>15)&0x1)==1){bt0[bt0i]=true;++bt0i;}else{bt0[bt0i]=false;++bt0i;}
				if(((((ga[2][1]&0x3)<<15)>>15)&0x1)==1){bt0[bt0i]=true;++bt0i;}else{bt0[bt0i]=false;++bt0i;}

				if(((((ga[3][1]&0x3)<<14)>>15)&0x1)==1){bt0[bt0i]=true;++bt0i;}else{bt0[bt0i]=false;++bt0i;}
				if(((((ga[3][1]&0x3)<<15)>>15)&0x1)==1){bt0[bt0i]=true;++bt0i;}else{bt0[bt0i]=false;++bt0i;}

				j=8-1;
				if(bt0[++j]){a23|=1<<1;}
				if(bt0[++j]){a23|=1<<0;}

				a24=0;
				if(bt0[++j]){a24|=1<<5;}
				if(bt0[++j]){a24|=1<<4;}
				if(bt0[++j]){a24|=1<<3;}
				if(bt0[++j]){a24|=1<<2;}
				if(bt0[++j]){a24|=1<<1;}
				if(bt0[++j]){a24|=1<<0;}

				//printf("%d %d %d %d\n",a21,a22,a23,a24);

				b=a21;
				if(ca6i_==0){ca6_[ca6i_]=b;vgmi=ca6i_;++ca6i_;}else{
					for(a=0;a<ca6i_;++a){if(ca6_[a]==b){vgmi=a;break;}}
					if(a==ca6i_){ca6_[ca6i_]=b;vgmi=ca6i_;++ca6i_;}
				}
				ca_[cai_]=vgmi;++cai_;
				b=a22;
				for(a=0;a<ca6i_;++a){if(ca6_[a]==b){vgmi=a;break;}}
				if(a==ca6i_){ca6_[ca6i_]=b;vgmi=ca6i_;++ca6i_;}
				ca_[cai_]=vgmi;++cai_;
				b=a23;
				for(a=0;a<ca6i_;++a){if(ca6_[a]==b){vgmi=a;break;}}
				if(a==ca6i_){ca6_[ca6i_]=b;vgmi=ca6i_;++ca6i_;}
				ca_[cai_]=vgmi;++cai_;
				b=a24;
				for(a=0;a<ca6i_;++a){if(ca6_[a]==b){vgmi=a;break;}}
				if(a==ca6i_){ca6_[ca6i_]=b;vgmi=ca6i_;++ca6i_;}
				ca_[cai_]=vgmi;++cai_;

				if(cai>=BuffC*16)
				{
					bytc=0;mw4_();
					//printf("\n+%d\n",bytc);
					fprintf(fo5,"%c%c",((bytc&0xff00)>>8),((bytc&0x00ff)>>0));
					bytc1=0;mw16_();
					fprintf(fo5,"%c%c",((bytc1&0xff00)>>8),((bytc1&0x00ff)>>0));

					cai_=0;cai=0;
					if(feof(f1)){break;}
				}
			}
		}
	}
	fclose(f1);
	fclose(fo5);
	fclose(fo3);

	//---------------------------------------

	fo4=fopen(out4fn,"ab");for(a=0;a<ca6i_;++a){fprintf(fo4,"%c",(ca6_[a]&0x00ff));bitc+=8;}fclose(fo4);

	fo6=fopen(out6fn,"ab");
	for(c=0;c<ba8i;++c)
	{
		for(i=0;i<16;++i){for(j=0;j<16;++j){
			if(ba8[i][j]==c){break;}
		}if(j!=16){break;}}
		fprintf(fo6,"%c",((i<<4)|j));bitc+=8;
	}
	fclose(fo6);

	fo7=fopen(out7fn,"ab");
	for(c=0;c<256;++c){if(md[c][0]!=-1){fprintf(fo7,"%c",c);fprintf(fo7,"%c",md[c][1]);bitc+=2*8;}}fclose(fo7);
	//-----------------------------------------

	//m_d();

	printf("compressed bytes %d , file bytes %d  (%d)%\n",(long)(bitc/8),(long)(fb/8),(100*(long)(bitc/8))/(long)(fb/8));

	return(0);

}

int main(int argc,char *argv[])
{

	int		a,b,c,ci,d;
	int		i,j,k,l,m;

	char	cmd[50][256];
	char	c_1[256];
	char	c_2[256];

	char	fn[10][2];int	fi=0;
	int		op=0;


	
	
//	256

//	000 : 000 - 000,003,012,015,048,051,060,063,192,195,204,207,240,243,252,255,
//	001 : 001 - 001,002,013,014,049,050,061,062,193,194,205,206,241,242,253,254,
//	004 : 004 - 004,007,008,011,052,055,056,059,196,199,200,203,244,247,248,251,
//	005 : 005 - 005,006,009,010,053,054,057,058,197,198,201,202,245,246,249,250,
//	016 : 016 - 016,019,028,031,032,035,044,047,208,211,220,223,224,227,236,239,
//	017 : 017 - 017,018,029,030,033,034,045,046,209,210,221,222,225,226,237,238,
//	020 : 020 - 020,023,024,027,036,039,040,043,212,215,216,219,228,231,232,235,
//	021 : 021 - 021,022,025,026,037,038,041,042,213,214,217,218,229,230,233,234,
//	064 : 064 - 064,067,076,079,112,115,124,127,128,131,140,143,176,179,188,191,
//	065 : 065 - 065,066,077,078,113,114,125,126,129,130,141,142,177,178,189,190,
//	068 : 068 - 068,071,072,075,116,119,120,123,132,135,136,139,180,183,184,187,
//	069 : 069 - 069,070,073,074,117,118,121,122,133,134,137,138,181,182,185,186,
//	080 : 080 - 080,083,092,095,096,099,108,111,144,147,156,159,160,163,172,175,
//	081 : 081 - 081,082,093,094,097,098,109,110,145,146,157,158,161,162,173,174,
//	084 : 084 - 084,087,088,091,100,103,104,107,148,151,152,155,164,167,168,171,
//	085 : 085 - 085,086,089,090,101,102,105,106,149,150,153,154,165,166,169,170,

	bpa[0][0]=0  ;bpa[0][1]=4  ;bpa[0][2]=16 ;bpa[0][3]=20 ;bpa[0][4]=64 ;bpa[0][5]=68 ;bpa[0][6]=80 ;bpa[0][7]=84 ;
	bpa[1][0]=12 ;bpa[1][1]=8  ;bpa[1][2]=28 ;bpa[1][3]=24 ;bpa[1][4]=76 ;bpa[1][5]=72 ;bpa[1][6]=92 ;bpa[1][7]=88 ;
	bpa[2][0]=48 ;bpa[2][1]=52 ;bpa[2][2]=32 ;bpa[2][3]=36 ;bpa[2][4]=112;bpa[2][5]=116;bpa[2][6]=96 ;bpa[2][7]=100;
	bpa[3][0]=60 ;bpa[3][1]=56 ;bpa[3][2]=44 ;bpa[3][3]=40 ;bpa[3][4]=124;bpa[3][5]=120;bpa[3][6]=108;bpa[3][7]=104;
	bpa[4][0]=192;bpa[4][1]=196;bpa[4][2]=208;bpa[4][3]=212;bpa[4][4]=128;bpa[4][5]=132;bpa[4][6]=144;bpa[4][7]=148;
	bpa[5][0]=204;bpa[5][1]=200;bpa[5][2]=220;bpa[5][3]=216;bpa[5][4]=140;bpa[5][5]=136;bpa[5][6]=156;bpa[5][7]=152;
	bpa[6][0]=240;bpa[6][1]=244;bpa[6][2]=224;bpa[6][3]=228;bpa[6][4]=176;bpa[6][5]=180;bpa[6][6]=160;bpa[6][7]=164;
	bpa[7][0]=252;bpa[7][1]=248;bpa[7][2]=236;bpa[7][3]=232;bpa[7][4]=188;bpa[7][5]=184;bpa[7][6]=172;bpa[7][7]=168;

	for(i=0;i<256;++i){for(j=0;j<256;++j){for(k=0;k<256;++k){
		ca6[i][j][k]=-1;
	}}}ca6i=0;

	for(i=0;i<16;++i){for(j=0;j<16;++j){
		ba8[i][j]=-1;
	}}ba8i=0;

	for(i=0;i<256;++i){md[i][0]=-1;}mdi=0;


	for(i=0;i<50;++i){for(j=0;j<256;++j){cmd[i][j]='\0';}}
	for(i=0;i<argc;++i){strcpy(cmd[i],argv[i]);}


	//
	printf("\n6-bit Binary Compression\n");
	printf("written by Dzinleski Jasenko 2008,2009,2010\n");
	printf("\nOS Win32 VRM 3.3.0\n\n");
	//


	//|	-
	ci=1;
	for(i=0;i<256;++i){c_1[i]='\0';}
	c_p(c_l,ci,true,c_1);
	//for(i=0;i<strlen(c_1);++i){printf("%c",c_1[i]);}

	ci=1;
	for(i=0;i<256;++i){c_2[i]='\0';}
	c_p(c_1,ci,false,c_2);
	//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

	if(cmd[1][0]==c_2[0]||cmd[1][0]==c_2[1]){}else{return(0);}
	//|


	//|	h , e , c , d 
	ci=2;
	for(i=0;i<256;++i){c_1[i]='\0';}
	c_p(c_l,ci,true,c_1);
	//for(i=0;i<strlen(c_1);++i){printf("%c",c_1[i]);}

	ci=1;
	for(i=0;i<256;++i){c_2[i]='\0';}
	c_p(c_1,ci,false,c_2);
	//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

	if(cmd[1][1]==c_2[0]||cmd[1][1]==c_2[1]){op=1;/*printf("h");*/}

	ci=2;
	for(i=0;i<256;++i){c_2[i]='\0';}
	c_p(c_1,ci,false,c_2);
	//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

	if(cmd[1][1]==c_2[0]||cmd[1][1]==c_2[1]){op=2;/*printf("l");*/}

	ci=3;
	for(i=0;i<256;++i){c_2[i]='\0';}
	c_p(c_1,ci,false,c_2);
	//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

	if(cmd[1][1]==c_2[0]||cmd[1][1]==c_2[1]){op=3;/*printf("c");*/}

	ci=4;
	for(i=0;i<256;++i){c_2[i]='\0';}
	c_p(c_1,ci,false,c_2);
	//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

	if(cmd[1][1]==c_2[0]||cmd[1][1]==c_2[1]){op=4;/*printf("d");*/}

	if(!(op==1||op==2||op==3||op==4)){return(0);}else{




		if(op==1)
		{

					printf("\n6-bit Binary Compression\n");
					printf("written by Dzinleski Jasenko 2008,2009,2010\n");
					printf("\nOS Win32 VRM 3.3.0\n\n");
					printf("\n");
					printf("mar6_xxx -c <filename to compress>\n");
					printf("mar6_xxx -d <compressed filename> [<output filename>]\n");
					printf("\n");

			return(0);

		}

		if(op==2)
		{

					printf("\n6-bit Binary Compression\n");
					printf("written by Dzinleski Jasenko 2008,2009,2010\n");
					printf("\nOS Win32 VRM 3.3.0\n\n");
					printf("\n");
					printf("\tThis source and compression method apply to GNU General Public License.\n");
					printf("\t		Copyright (C) 2008,2009,2010 Jasenko Dzinleski \n");
					printf("\n");
					printf("\t	This program is free software; you can redistribute it\n");
					printf("\tand/or modify it under the terms of the GNU General Public License as\n");
					printf("\tpublished by the Free Software Foundation; either version 2 of the\n");
					printf("\tLicense, or (at your option) any later version.\n");
					printf("\n");
					printf("\tThis program is distributed in the hope that it will be useful, but\n");
					printf("\tWITHOUT ANY WARRANTY; without even the implied warranty of\n");
					printf("\tMERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU\n");
					printf("\tGeneral Public License for more details.\n");
					printf("\n");
					printf("\tYou should have received a copy of the GNU General Public License along\n");
					printf("\twith this program; if not, write to the Free Software Foundation, Inc.,\n");
					printf("\t51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.\n");
					printf("\n");


			return(0);
		}

		if(op==3)
		{

		//|	<filename>
		ci=3;
		for(i=0;i<256;++i){c_1[i]='\0';}
		c_p(c_l,ci,true,c_1);
		//for(i=0;i<strlen(c_1);++i){printf("%c",c_1[i]);}

		ci=1;
		for(i=0;i<256;++i){c_2[i]='\0';}
		c_p(c_1,ci,false,c_2);
		//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

		fn[fi][0]=c_2[0];fn[fi][1]=c_2[1];++fi;

		ci=2;
		for(i=0;i<256;++i){c_2[i]='\0';}
		c_p(c_1,ci,false,c_2);
		//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

		fn[fi][0]=c_2[0];fn[fi][1]=c_2[1];++fi;

		ci=3;
		for(i=0;i<256;++i){c_2[i]='\0';}
		c_p(c_1,ci,false,c_2);
		//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

		fn[fi][0]=c_2[0];fn[fi][1]=c_2[1];++fi;

		ci=4;
		for(i=0;i<256;++i){c_2[i]='\0';}
		c_p(c_1,ci,false,c_2);
		//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

		fn[fi][0]=c_2[0];fn[fi][1]=c_2[1];++fi;

		ci=5;
		for(i=0;i<256;++i){c_2[i]='\0';}
		c_p(c_1,ci,false,c_2);
		//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

		fn[fi][0]=c_2[0];fn[fi][1]=c_2[1];++fi;

		ci=6;
		for(i=0;i<256;++i){c_2[i]='\0';}
		c_p(c_1,ci,false,c_2);
		//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

		fn[fi][0]=c_2[0];fn[fi][1]=c_2[1];++fi;
		//|


		for(i=0;i<strlen(cmd[2]);++i)
		{
			if
				(
				(cmd[2][i]>=fn[0][0]&&cmd[2][i]<=fn[0][1])||
				(cmd[2][i]>=fn[1][0]&&cmd[2][i]<=fn[1][1])||
				(cmd[2][i]>=fn[2][0]&&cmd[2][i]<=fn[2][1])||
				(cmd[2][i]>=fn[3][0]&&cmd[2][i]<=fn[3][1])||
				(cmd[2][i]>=fn[4][0]&&cmd[2][i]<=fn[4][1])||
				(cmd[2][i]>=fn[5][0]&&cmd[2][i]<=fn[5][1])
				){}else{break;}
		}
		if(i==strlen(cmd[2])){/*printf("?");*/}else{return(0);}
		//|

		f_n(cmd[2],"");
		m_m(cmd[2]);

		}

		if(op==4)
		{

		//|	<filename>
		ci=3;
		for(i=0;i<256;++i){c_1[i]='\0';}
		c_p(c_l,ci,true,c_1);
		//for(i=0;i<strlen(c_1);++i){printf("%c",c_1[i]);}

		ci=1;
		for(i=0;i<256;++i){c_2[i]='\0';}
		c_p(c_1,ci,false,c_2);
		//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

		fn[fi][0]=c_2[0];fn[fi][1]=c_2[1];++fi;

		ci=2;
		for(i=0;i<256;++i){c_2[i]='\0';}
		c_p(c_1,ci,false,c_2);
		//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

		fn[fi][0]=c_2[0];fn[fi][1]=c_2[1];++fi;

		ci=3;
		for(i=0;i<256;++i){c_2[i]='\0';}
		c_p(c_1,ci,false,c_2);
		//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

		fn[fi][0]=c_2[0];fn[fi][1]=c_2[1];++fi;

		ci=4;
		for(i=0;i<256;++i){c_2[i]='\0';}
		c_p(c_1,ci,false,c_2);
		//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

		fn[fi][0]=c_2[0];fn[fi][1]=c_2[1];++fi;

		ci=5;
		for(i=0;i<256;++i){c_2[i]='\0';}
		c_p(c_1,ci,false,c_2);
		//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

		fn[fi][0]=c_2[0];fn[fi][1]=c_2[1];++fi;

		ci=6;
		for(i=0;i<256;++i){c_2[i]='\0';}
		c_p(c_1,ci,false,c_2);
		//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

		fn[fi][0]=c_2[0];fn[fi][1]=c_2[1];++fi;
		//|


		for(i=0;i<strlen(cmd[2]);++i)
		{
			if
				(
				(cmd[2][i]>=fn[0][0]&&cmd[2][i]<=fn[0][1])||
				(cmd[2][i]>=fn[1][0]&&cmd[2][i]<=fn[1][1])||
				(cmd[2][i]>=fn[2][0]&&cmd[2][i]<=fn[2][1])||
				(cmd[2][i]>=fn[3][0]&&cmd[2][i]<=fn[3][1])||
				(cmd[2][i]>=fn[4][0]&&cmd[2][i]<=fn[4][1])||
				(cmd[2][i]>=fn[5][0]&&cmd[2][i]<=fn[5][1])
				){}else{break;}
		}
		if(i==strlen(cmd[2])){/*printf("?");*/}else{return(0);}
		//|

		if(strlen(cmd[3])!=0){f_n(cmd[2],cmd[3]);}else{f_n(cmd[2],NULL);}
		m_d();

		}




	}
	//|
	
	return(0);

}

